{$I-}

procedure ERR(s : string);
begin
   writeln(400);
   writeln('Error: ', s);
   halt(0);
end;

procedure OK(n : integer; s : string);
begin
   writeln(200);
   writeln('Score: ', n);
   writeln('Error: ', s);
   halt(0);
end;

const
   sis = 'vl.sis';
   val = 'vl.val';
   max = 1000;                               { maksimaalne valijameeste arv }

var
   f : text;
   n : integer;                                            { osariikide arv }
   m : integer;                                          { valijameeste arv }
   a : array [0..max] of integer;    { a[x] - x valijamehega osariikide arv }
   s : array [0..max] of boolean;        { s[x] - kas summa s on saavutatav }
   v : boolean;                       { kas president saab kindlalt valitud }
   i, j, x, y : integer;
   i1, i2 : integer;
   t : string;

begin
   { loeme sisendandmed ja leiame saavutatavad summad }
   assign (f, sis); reset (f);
   if ioresult > 0 then
      ERR('Viga sisendfaili avamisel');

   readln (f, n);
   if ioresult > 0 then
      ERR('Viga sisendfaili lugemisel');

   m := 0;
   for i := 0 to max do begin
      a[i] := 0;
      s[i] := false;
   end;
   s[0] := true;

   for i := 1 to n do begin
      read (f, x);
      if ioresult > 0 then
         ERR('Viga sisendfaili lugemisel');

      m := m + x;
      a[x] := a[x] + 1;
      for j := m downto 0 do
         if s[j] and (j + x <= max) then
            if not s[j + x] then
               s[j + x] := true;
   end;

   close (f);
   if ioresult > 0 then
         ERR('Viga sisendfaili sulgemisel');

   { kas pool valijameeste arvust on saavutatav summa? }
   if (m mod 2 = 1) then
      v := true
   else
      v := not s[m div 2];

   { kui president saab valitud, leiame hlte vahe }
   if v then begin
      i1 := m div 2;
      while (i1 > 0) and (not s[i1]) do
         i1 := i1 - 1;
      i2 := m div 2 + 1;
      while (i2 < m) and (not s[i2]) do
         i2 := i2 + 1;
      { kontrolltingimus: i1 + i2 = m }
      if i1 + i2 <> m then
         ERR('Sisemine vastuolu testimisprogrammis');
      x := i2 - i1;
      { kontrolltingimus: x > 0 }
      if x = 0 then
         ERR('Sisemine vastuolu testimisprogrammis');
   end;

   { loeme vistleja vastuse }
   assign (f, val); reset (f);
   if ioresult > 0 then
      ERR('Viga vljundfaili avamisel');

   readln (f, t);
   if ioresult > 0 then
      OK(0, 'Viga vljundfaili lugemisel');

   if v then begin
      if (t <> 'JAH') then
         OK(0, 'Vale vastus ' + t);

      readln (f, y, t);
      if ioresult > 0 then
         OK(0, 'Viga vljundfaili lugemisel');

      if x <> y then
         OK(0, 'Vale hlte vahe');
   end else begin
      if (t <> 'EI') then
         OK(0, 'Vale vastus ' + t);

      x := 0;
      while not seekeoln (f) do begin
         read (f, y);
         if ioresult > 0 then
            OK(0, 'Viga vljundfaili lugemisel');

         if (y < 0) or (y > max) or (a[y] = 0) then
            OK(0, 'Lubamatu valijameeste arv');
         a[y] := a[y] - 1;
         x := x + y;
      end;

      if x <> m div 2 then
         OK(0, 'Vale hlte summa');
   end;

   close (f);
   if ioresult > 0 then
      ERR('Viga vljundfaili sulgemisel');
   OK(100, 'OK');
end.
